# refs #54
#include OpenEhr::RM::DataStructures::ItemStructure
#include OpenEhr::RM::DataStructures::ItemStructure::Representation
#include OpenEhr::RM::DataTypes::Text

class TestItemStructre < Test::Unit::TestCase
  def setup
    name = DvText.new('item structure')
    @item_structure = OpenEhr::RM::DataStructures::ItemStructure::ItemStructure.new(:name => name,
                                        :archetype_node_id => 'test')
  end

  def test_init
    assert_instance_of OpenEhr::RM::DataStructures::ItemStructure::ItemStructure, @item_structure
  end
end

class TestItemSingle < Test::Unit::TestCase
  def setup
    name = DvText.new('test_element')
    @element = OpenEhr::RM::DataStructures::ItemStructure::Representation::Element.new(:name => name,
                           :archetype_node_id => 'test_element')
    item_single_name = DvText.new('item single')
    @item_single = OpenEhr::RM::DataStructures::ItemStructure::ItemSingle.new(:name => item_single_name,
                                  :archetype_node_id => 'test',
                                  :item => @element)
  end

  def test_init
    assert_instance_of OpenEhr::RM::DataStructures::ItemStructure::ItemSingle, @item_single
  end

  def test_element
    assert_equal @element, @item_single.item
  end

  def test_as_hierarchy
    @item_single.item = @element
    assert_equal 'test_element', @item_single.as_hierarchy.name.value
  end

  def test_item_valid
    invalid_element = nil
    assert_raise(ArgumentError){@item_single.item = invalid_element}
  end
end
class TestItemList < Test::Unit::TestCase
  def setup
    element_name = DvText.new('test_element')
    @element = OpenEhr::RM::DataStructures::ItemStructure::Representation::Element.new(:name => element_name,
                           :archetype_node_id => 'test_element')
    item_list_name = DvText.new('item list name')
    @item_list = OpenEhr::RM::DataStructures::ItemStructure::ItemList.new(:name => item_list_name,
                              :archetype_node_id => 'item list')
  end

  def test_init
    assert_instance_of OpenEhr::RM::DataStructures::ItemStructure::ItemList, @item_list
  end
end
